// dlg.cpp : implementation file
//


#include "stdafx.h"
#include "tvgames.h"
#include "dlg.h"

#include "conio.h"	// getch Function Declaration


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CColorsDlg dialog

CColorsDlg::CColorsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CColorsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CColorsDlg)
	m_selInk = "";
	m_selPaper = "";
	//}}AFX_DATA_INIT
}

void CColorsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColorsDlg)
	DDX_Control(pDX, IDC_PAPER, m_paper);
	DDX_Control(pDX, IDC_INK, m_ink);
	DDX_CBString(pDX, IDC_INK, m_selInk);
	DDX_CBString(pDX, IDC_PAPER, m_selPaper);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CColorsDlg, CDialog)
	//{{AFX_MSG_MAP(CColorsDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorsDlg message handlers

BOOL CColorsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Fill the Combo Boxes
	extern const int NUM_COLORS;
	extern const char* COLOR_NAMES[];

	for (int i=0; i<NUM_COLORS; i++)
	{
		m_ink.AddString(COLOR_NAMES[i]);
		m_paper.AddString(COLOR_NAMES[i]);
	}

	m_ink.SelectString(-1,m_selInk);
	m_paper.SelectString(-1,m_selPaper);
	
	CenterWindow();
	return TRUE;
}





/////////////////////////////////////////////////////////////////////////////
// CComputerSkillDlg dialog

CComputerSkillDlg::CComputerSkillDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CComputerSkillDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CComputerSkillDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CComputerSkillDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CComputerSkillDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CComputerSkillDlg, CDialog)
	//{{AFX_MSG_MAP(CComputerSkillDlg)
	ON_BN_CLICKED(IDC_FAST, OnClickedFast)
	ON_BN_CLICKED(IDC_MEDIUM, OnClickedMedium)
	ON_BN_CLICKED(IDC_SLOW, OnClickedSlow)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComputerSkillDlg message handlers

BOOL CComputerSkillDlg::OnInitDialog()
{
	CString speed;
	CDialog::OnInitDialog();

	if (m_computerSkill==COMPUTER_LO_SPEED)
	{
		SetDefID(IDC_SLOW);
		GetDlgItem(IDC_SLOW)->SetFocus();
		GetDlgItem(IDC_SLOW)->GetWindowText(speed);
	}    
	if (m_computerSkill==COMPUER_MED_SPEED)
	{
		SetDefID(IDC_MEDIUM);
		GetDlgItem(IDC_MEDIUM)->SetFocus();
		GetDlgItem(IDC_MEDIUM)->GetWindowText(speed);
	}
	
	if (m_computerSkill==COMPUTER_HI_SPEED)
	{
		SetDefID(IDC_FAST);
		GetDlgItem(IDC_FAST)->SetFocus();
		GetDlgItem(IDC_FAST)->GetWindowText(speed);
	}

	GetDlgItem(IDC_SPEED)->SetWindowText(speed);

	CenterWindow();
	return FALSE;
}

void CComputerSkillDlg::OnClickedFast()
{
	m_computerSkill = COMPUTER_HI_SPEED;
	OnOK();
}

void CComputerSkillDlg::OnClickedMedium()
{
	m_computerSkill = COMPUER_MED_SPEED;
	OnOK();
}

void CComputerSkillDlg::OnClickedSlow()
{
	m_computerSkill = COMPUTER_LO_SPEED;
	OnOK();
}





/////////////////////////////////////////////////////////////////////////////
// CKeyboardDlg dialog

CKeyboardDlg::CKeyboardDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKeyboardDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKeyboardDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CKeyboardDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeyboardDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP

    m_pAskingWnd = NULL;
}

BEGIN_MESSAGE_MAP(CKeyboardDlg, CDialog)
	//{{AFX_MSG_MAP(CKeyboardDlg)
	ON_BN_CLICKED(IDC_CHANGE1D, OnChangeP1Down)
	ON_BN_CLICKED(IDC_CHANGE1U, OnChangeP1Up)
	ON_BN_CLICKED(IDC_CHANGE2D, OnChangeP2Down)
	ON_BN_CLICKED(IDC_CHANGE2U, OnChangeP2Up)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyboardDlg message handlers

BOOL CKeyboardDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	GetDlgItem(IDC_1UP)->SetWindowText(GetVirtualKeyName(m_p1Up));
	GetDlgItem(IDC_1DOWN)->SetWindowText(GetVirtualKeyName(m_p1Down));
	GetDlgItem(IDC_2UP)->SetWindowText(GetVirtualKeyName(m_p2Up));
	GetDlgItem(IDC_2DOWN)->SetWindowText(GetVirtualKeyName(m_p2Down));
	
	CenterWindow();
	return TRUE;
}

void CKeyboardDlg::OnChangeP1Up()
{
	if (m_pAskingWnd!=NULL)
		return;
		
	m_pAskingWnd = new CWaitKeyDlg;

	if (m_pAskingWnd==0)
	{
		m_pAskingWnd = NULL;
		AfxMessageBox("Can' create window.",MB_ICONSTOP);
		return;
	}

	((CWaitKeyDlg*)m_pAskingWnd)->m_player = "1";
	((CWaitKeyDlg*)m_pAskingWnd)->m_direction = "Up";
	((CWaitKeyDlg*)m_pAskingWnd)->m_pOwnerWnd = this;
	((CWaitKeyDlg*)m_pAskingWnd)->Create(this);
	m_pAskingWnd->UpdateWindow();
	m_pAskingWnd->ShowWindow(SW_SHOW);               
	m_pAskingWnd->SetFocus();               
	
	m_pUpdatingKey = &m_p1Up;
}

void CKeyboardDlg::OnChangeP1Down()
{
	if (m_pAskingWnd!=NULL)
		return;
		
	m_pAskingWnd = new CWaitKeyDlg;

	if (m_pAskingWnd==0)
	{
		m_pAskingWnd = NULL;
		AfxMessageBox("Can' create window.",MB_ICONSTOP);
		return;
	}

	((CWaitKeyDlg*)m_pAskingWnd)->m_player = "1";
	((CWaitKeyDlg*)m_pAskingWnd)->m_direction = "Down";
	((CWaitKeyDlg*)m_pAskingWnd)->m_pOwnerWnd = this;
	((CWaitKeyDlg*)m_pAskingWnd)->Create(this);
	m_pAskingWnd->UpdateWindow();
	m_pAskingWnd->ShowWindow(SW_SHOW);               
	m_pAskingWnd->SetFocus();               
	
	m_pUpdatingKey = &m_p1Down;
}

void CKeyboardDlg::OnChangeP2Up()
{
	if (m_pAskingWnd!=NULL)
		return;
		
	m_pAskingWnd = new CWaitKeyDlg;

	if (m_pAskingWnd==0)
	{
		m_pAskingWnd = NULL;
		AfxMessageBox("Can' create window.",MB_ICONSTOP);
		return;
	}

	((CWaitKeyDlg*)m_pAskingWnd)->m_player = "2";
	((CWaitKeyDlg*)m_pAskingWnd)->m_direction = "Up";
	((CWaitKeyDlg*)m_pAskingWnd)->m_pOwnerWnd = this;
	((CWaitKeyDlg*)m_pAskingWnd)->Create(this);
	m_pAskingWnd->UpdateWindow();
	m_pAskingWnd->ShowWindow(SW_SHOW);               
	m_pAskingWnd->SetFocus();               
	
	m_pUpdatingKey = &m_p2Up;
}

void CKeyboardDlg::OnChangeP2Down()
{
	if (m_pAskingWnd!=NULL)
		return;
		
	m_pAskingWnd = new CWaitKeyDlg;

	if (m_pAskingWnd==0)
	{
		m_pAskingWnd = NULL;
		AfxMessageBox("Can' create window.",MB_ICONSTOP);
		return;
	}

	((CWaitKeyDlg*)m_pAskingWnd)->m_player = "2";
	((CWaitKeyDlg*)m_pAskingWnd)->m_direction = "Down";
	((CWaitKeyDlg*)m_pAskingWnd)->m_pOwnerWnd = this;
	((CWaitKeyDlg*)m_pAskingWnd)->Create(this);
	m_pAskingWnd->UpdateWindow();
	m_pAskingWnd->ShowWindow(SW_SHOW);               
	m_pAskingWnd->SetFocus();               
	
	m_pUpdatingKey = &m_p2Down;
}

void CKeyboardDlg::KeyPressed(UINT keyPressed)
{
	// Delete Dialog	
	if (m_pAskingWnd!=NULL)
	{
		m_pAskingWnd->SendMessage(WM_CLOSE);
    	m_pAskingWnd = NULL;
    }

	if ((keyPressed==0)
		|| (keyPressed==(*m_pUpdatingKey)))
		return;
	
	// No Accelerators
	if ((keyPressed==VK_ESCAPE)
		|| (keyPressed==VK_F2)
		|| (keyPressed==VK_F3)
		|| (keyPressed==VK_CONTROL)
		|| (keyPressed==VK_MENU))
	{
		CString msg = GetVirtualKeyName(keyPressed);
		msg += ": invalid key.";
		AfxMessageBox(msg,MB_ICONEXCLAMATION);
		return;
	}          
	
	// No Duplicate Commands
	if ((keyPressed==m_p1Up)
		|| (keyPressed==m_p1Down)
		|| (keyPressed==m_p2Up)
		|| (keyPressed==m_p2Down))
	{
		CString msg = GetVirtualKeyName(keyPressed);
		msg += ": key already used.";
		AfxMessageBox(msg,MB_ICONEXCLAMATION);
		return;
	}          

	// Store New Command Key
	*m_pUpdatingKey = keyPressed;	

	// Update Key Names
	GetDlgItem(IDC_1UP)->SetWindowText(GetVirtualKeyName(m_p1Up));
	GetDlgItem(IDC_1DOWN)->SetWindowText(GetVirtualKeyName(m_p1Down));
	GetDlgItem(IDC_2UP)->SetWindowText(GetVirtualKeyName(m_p2Up));
	GetDlgItem(IDC_2DOWN)->SetWindowText(GetVirtualKeyName(m_p2Down));
}

void CKeyboardDlg::CloseAskingWindow()
{
	// Delete Dialog	
	if (m_pAskingWnd!=NULL)
	{
		m_pAskingWnd->PostMessage(WM_CLOSE);
    	m_pAskingWnd = NULL;
    } 
}

void CKeyboardDlg::OnCancel()
{
	// Delete Dialog	
	CloseAskingWindow();
	
	CDialog::OnCancel();
}

void CKeyboardDlg::OnOK()
{
	// Delete Dialog	
	CloseAskingWindow();
	
	CDialog::OnOK();
}





/////////////////////////////////////////////////////////////////////////////
// CWaitKeyDlg Window

IMPLEMENT_DYNCREATE(CWaitKeyDlg,CWnd);

#define WKD_ID		4096
#define WKD_WIDTH	150
#define WKD_HEIGHT	60
#define WKD_MARGIN	5


#define WKD_FONT_HEIGHT	8
#define WKD_FONT_NAME	"MS Sans Serif"

#define WKD_BK_COLOR	RGB(0xc0,0xc0,0xc0)
#define WKD_TXT_COLOR 	RGB(0x00,0x00,0x00)

BOOL CWaitKeyDlg::Create(CWnd* pParent /*=NULL*/)
{
	CRect wndRect(CFrameWnd::rectDefault);
	
	if (m_pOwnerWnd!=NULL)
	{
		CRect pRect;
		m_pOwnerWnd->GetWindowRect(pRect);
		wndRect.top = pRect.top + (pRect.Height() - WKD_HEIGHT)/2;
		wndRect.left = pRect.left + (pRect.Width() - WKD_WIDTH)/2;
	}	
                
	wndRect.right = wndRect.left + WKD_WIDTH;
	wndRect.bottom = wndRect.top + WKD_HEIGHT;
	                
	BOOL res = CWnd::CreateEx(0,"AfxControlBar",NULL,
							  WS_POPUP|WS_VISIBLE|WS_DLGFRAME,wndRect.left,
							  wndRect.top,wndRect.Width(),wndRect.Height(),
							  pParent->m_hWnd,(HMENU)NULL);
	return res;
}

BEGIN_MESSAGE_MAP(CWaitKeyDlg, CWnd)
	//{{AFX_MSG_MAP(CWaitKeyDlg)
	ON_WM_KEYDOWN()
	ON_WM_PAINT()
	ON_WM_KILLFOCUS()
	ON_WM_SYSKEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWaitKeyDlg message handlers

void CWaitKeyDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	m_pOwnerWnd->KeyPressed(nChar);
}

void CWaitKeyDlg::OnSysKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	m_pOwnerWnd->KeyPressed(nChar);
}

void CWaitKeyDlg::OnPaint()
{
	CPaintDC dc(this);
	InvalidateRect(NULL);
	
	CRect clientArea;
	GetClientRect(clientArea);

	// Select the Background Brush
	CBrush bkBrush;
	bkBrush.CreateSolidBrush(WKD_BK_COLOR);
	
	// Paint the Background
	dc.FillRect(clientArea,&bkBrush);	
	bkBrush.DeleteObject();
	
	// Text Properties
	COLORREF oldBkColor = dc.SetBkColor(WKD_BK_COLOR);	
	COLORREF oldTextColor = dc.SetTextColor(WKD_TXT_COLOR);	
	
	// Create Font
	CFont font, *pOldFont = NULL;
	if (font.CreateFont(-WKD_FONT_HEIGHT,0,	// Height & Width
						0,0,				// Escapement & Orientation
						FW_BOLD,			// Weight
						0,0,				// Italic, Underlined
						0,DEFAULT_CHARSET,	// StrickeOut, CharSet
						OUT_DEFAULT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,
						DEFAULT_PITCH,
						WKD_FONT_NAME))		// Face Name
	{	
		pOldFont = dc.SelectObject(&font);	
    }
    
	// Write Text        
	CSize textExt = dc.GetOutputTextExtent("ABC",3);
	
	int y = WKD_MARGIN;
	CString line = "Player ";
	line += m_player;
	dc.TextOut(WKD_MARGIN,y,line);
	y += textExt.cy + 2;
	
	line = "Direction: ";
	line += m_direction;
	dc.TextOut(WKD_MARGIN,y,line);
	y += textExt.cy + 2;
	
	line = "         Press a key...";
	dc.TextOut(WKD_MARGIN,y,line);
	
	dc.SetBkColor(oldBkColor);	
	dc.SetTextColor(oldTextColor);	

	if (pOldFont!=NULL)
	{
		dc.SelectObject(pOldFont);
		font.DeleteObject();
	}
	
	ValidateRect(NULL);
}

void CWaitKeyDlg::OnKillFocus(CWnd* pNewWnd)
{
	CWnd::OnKillFocus(pNewWnd);
	
	// Delete Window
	m_pOwnerWnd->CloseAskingWindow();
}

void CWaitKeyDlg::PostNcDestroy()
{
	CWnd::PostNcDestroy();
	
	// Allow Auto Clean Up
	delete this;
}


 
 
 
/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog

COptionsDlg::COptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionsDlg)
	m_accelerated = FALSE;
	m_effect = FALSE;
	m_largeBats = FALSE;
	m_sound = FALSE;
	m_hiSpeed = FALSE;
	m_winnerScore = 0;
	m_scoresAlwaysOnTop = FALSE;
	m_currGame = "";
	//}}AFX_DATA_INIT
}

void COptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDlg)
	DDX_Control(pDX, IDC_GAMES, m_games);
	DDX_Check(pDX, IDC_ACCELERATION, m_accelerated);
	DDX_Check(pDX, IDC_EFFECT, m_effect);
	DDX_Check(pDX, IDC_LARGEBATS, m_largeBats);
	DDX_Check(pDX, IDC_SOUND, m_sound);
	DDX_Check(pDX, IDC_HIGHSPEED, m_hiSpeed);
	DDX_Text(pDX, IDC_WINNERSCORE, m_winnerScore);
	DDV_MinMaxInt(pDX, m_winnerScore, 1, 15);
	DDX_Check(pDX, IDC_SCORESONTOP, m_scoresAlwaysOnTop);
	DDX_CBString(pDX, IDC_GAMES, m_currGame);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COptionsDlg, CDialog)
	//{{AFX_MSG_MAP(COptionsDlg)
	ON_BN_CLICKED(IDC_COLORS, OnClickedColors)
	ON_BN_CLICKED(IDC_KEYS, OnClickedKeys)
	ON_BN_CLICKED(IDC_DEFAULTS, OnClickedDefaults)
	ON_BN_CLICKED(IDC_SKILL, OnClickedSkill)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_SAVE, OnClickedSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg message handlers

BOOL COptionsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Prepare Scroll Bars
	((CScrollBar*)GetDlgItem(IDC_LOWSPEEDVALUE))->SetScrollRange(MIN_SPEED_VALUE,MAX_SPEED_VALUE,FALSE);
	((CScrollBar*)GetDlgItem(IDC_HIGHSPEEDVALUE))->SetScrollRange(MIN_SPEED_VALUE,MAX_SPEED_VALUE,FALSE);
	((CScrollBar*)GetDlgItem(IDC_BIGBAT))->SetScrollRange(MIN_BAT_HEIGHT,MAX_BAT_HEIGHT,FALSE);
	((CScrollBar*)GetDlgItem(IDC_SMALLBAT))->SetScrollRange(MIN_BAT_HEIGHT,MAX_BAT_HEIGHT,FALSE);
	((CScrollBar*)GetDlgItem(IDC_BALLWIDTH))->SetScrollRange(MIN_BALL_WIDTH,MAX_BALL_WIDTH,FALSE);
	((CScrollBar*)GetDlgItem(IDC_MAX_EFFECT))->SetScrollRange(0,MAX_BALL_EFFECT,FALSE);
	
	// Set Scroll Bars Positions
	((CScrollBar*)GetDlgItem(IDC_LOWSPEEDVALUE))->SetScrollPos(m_loSpeedValue);
	((CScrollBar*)GetDlgItem(IDC_HIGHSPEEDVALUE))->SetScrollPos(m_hiSpeedValue);
	((CScrollBar*)GetDlgItem(IDC_BIGBAT))->SetScrollPos(m_bigBatHeight);
	((CScrollBar*)GetDlgItem(IDC_SMALLBAT))->SetScrollPos(m_smallBatHeight);
	((CScrollBar*)GetDlgItem(IDC_BALLWIDTH))->SetScrollPos(m_ballWidth);
	((CScrollBar*)GetDlgItem(IDC_MAX_EFFECT))->SetScrollPos(m_maxEffect);
	
	char buffer[8];
	GetDlgItem(IDC_LS_VALUE)->SetWindowText(_itoa(m_loSpeedValue,buffer,10));
	GetDlgItem(IDC_HS_VALUE)->SetWindowText(_itoa(m_hiSpeedValue,buffer,10));
	GetDlgItem(IDC_BBH_VALUE)->SetWindowText(_itoa(m_bigBatHeight,buffer,10));
	GetDlgItem(IDC_SBH_VALUE)->SetWindowText(_itoa(m_smallBatHeight,buffer,10));
	GetDlgItem(IDC_BW_VALUE)->SetWindowText(_itoa(m_ballWidth,buffer,10));
	GetDlgItem(IDC_ME_VALUE)->SetWindowText(_itoa(m_maxEffect,buffer,10));

	// Fill Combo Box
	m_games.AddString(PELOTA_STR);
	m_games.AddString(TENNIS_STR);
	m_games.AddString(HOCKEY_STR);
	m_games.AddString(TRAINING_STR);
	
	m_games.SelectString(-1,m_currGame);
	
	CenterWindow();
	return TRUE;
}

void COptionsDlg::OnClickedColors()
{
	CColorsDlg dlg(this);
	
	dlg.m_selInk = GetColorName(m_ink);
	dlg.m_selPaper = GetColorName(m_paper);
	
	if (dlg.DoModal()==IDOK)
	{
		m_ink = GetColorValue(dlg.m_selInk);
		m_paper = GetColorValue(dlg.m_selPaper);
	}
}

void COptionsDlg::OnClickedKeys()
{
	CKeyboardDlg dlg(this);
	
	dlg.m_p1Up = m_upKeyP1;
	dlg.m_p1Down = m_downKeyP1;
	dlg.m_p2Up = m_upKeyP2;
	dlg.m_p2Down = m_downKeyP2;
	
	if (dlg.DoModal()==IDOK)
	{
		m_upKeyP1 = dlg.m_p1Up;
		m_downKeyP1 = dlg.m_p1Down;
		m_upKeyP2 = dlg.m_p2Up;
		m_downKeyP2 = dlg.m_p2Down;
	}
}

void COptionsDlg::OnClickedDefaults()
{
	m_currGame = DEF_GAME_TYPE;
	
	m_sound = DEF_SOUND;
	m_effect = DEF_BALL_EFFECT;
	m_hiSpeed = DEF_HIGH_SPEED;
	m_largeBats = DEF_LARGE_BATS;
	m_accelerated = DEF_ACCELERATED;
	m_scoresAlwaysOnTop = DEF_SCORES_ON_TOP;

	m_winnerScore = DEF_WINNER_SCORE;
	m_loSpeedValue = DEF_LOW_SPEED_VALUE;
	m_hiSpeedValue = DEF_HIGH_SPEED_VALUE;
	m_bigBatHeight = DEF_BIG_BAT_HEIGHT;
	m_smallBatHeight = DEF_SMALL_BAT_HEIGHT;
	m_ballWidth = DEF_BALL_WIDTH;
	m_maxEffect = DEF_EFFECT_ANGOLATION;
	
	m_ink = GetColorValue(DEF_INK_COLOR);
	m_paper = GetColorValue(DEF_PAPER_COLOR);
	
	m_upKeyP1 = DEF_PLAYER1_UP_KEY;
	m_downKeyP1 = DEF_PLAYER1_DOWN_KEY;
	m_upKeyP2 = DEF_PLAYER2_UP_KEY;
	m_downKeyP2 = DEF_PLAYER2_DOWN_KEY;
	
	m_computerSpeed = DEF_COMPUTER_SPEED;

	UpdateData(FALSE);

	// Set Scroll Bars Positions
	((CScrollBar*)GetDlgItem(IDC_LOWSPEEDVALUE))->SetScrollPos(m_loSpeedValue);
	((CScrollBar*)GetDlgItem(IDC_HIGHSPEEDVALUE))->SetScrollPos(m_hiSpeedValue);
	((CScrollBar*)GetDlgItem(IDC_BIGBAT))->SetScrollPos(m_bigBatHeight);
	((CScrollBar*)GetDlgItem(IDC_SMALLBAT))->SetScrollPos(m_smallBatHeight);
	((CScrollBar*)GetDlgItem(IDC_BALLWIDTH))->SetScrollPos(m_ballWidth);
	((CScrollBar*)GetDlgItem(IDC_MAX_EFFECT))->SetScrollPos(m_maxEffect);

	char buffer[8];
	GetDlgItem(IDC_LS_VALUE)->SetWindowText(_itoa(m_loSpeedValue,buffer,10));
	GetDlgItem(IDC_HS_VALUE)->SetWindowText(_itoa(m_hiSpeedValue,buffer,10));
	GetDlgItem(IDC_BBH_VALUE)->SetWindowText(_itoa(m_bigBatHeight,buffer,10));
	GetDlgItem(IDC_SBH_VALUE)->SetWindowText(_itoa(m_smallBatHeight,buffer,10));
	GetDlgItem(IDC_BW_VALUE)->SetWindowText(_itoa(m_ballWidth,buffer,10));
	GetDlgItem(IDC_ME_VALUE)->SetWindowText(_itoa(m_maxEffect,buffer,10));
}

void COptionsDlg::OnClickedSkill()
{
	CComputerSkillDlg dlg(this);
	dlg.m_computerSkill = m_computerSpeed;

	dlg.DoModal();
	
	m_computerSpeed = dlg.m_computerSkill;
}

void COptionsDlg::OnClickedSave()
{
	// Retrieve Data
	UpdateData();
	
	CTheApp* pApp = (CTheApp*)AfxGetApp();

	// Save INI Data
	pApp->WriteProfileString(CONFIG_SECTION,GAME_TYPE,m_currGame);
	pApp->WriteProfileInt(CONFIG_SECTION,SOUND,m_sound);
	pApp->WriteProfileInt(CONFIG_SECTION,HIGH_SPEED,m_hiSpeed);
	pApp->WriteProfileInt(CONFIG_SECTION,LARGE_BATS,m_largeBats);
	pApp->WriteProfileInt(CONFIG_SECTION,BALL_EFFECT,m_effect);
	pApp->WriteProfileInt(CONFIG_SECTION,ACCELERATED,m_accelerated);
	pApp->WriteProfileString(CONFIG_SECTION,INK_COLOR,GetColorName(m_ink));
	pApp->WriteProfileString(CONFIG_SECTION,PAPER_COLOR,GetColorName(m_paper));
	pApp->WriteProfileInt(CONFIG_SECTION,SCORES_ON_TOP,m_scoresAlwaysOnTop);

	pApp->WriteProfileInt(PARAM_SECTION,WINNER_SCORE,m_winnerScore);
	pApp->WriteProfileInt(PARAM_SECTION,LOW_SPEED_VALUE,m_loSpeedValue);
	pApp->WriteProfileInt(PARAM_SECTION,HIGH_SPEED_VALUE,m_hiSpeedValue);
	pApp->WriteProfileInt(PARAM_SECTION,BIG_BAT_HEIGHT,m_bigBatHeight);
	pApp->WriteProfileInt(PARAM_SECTION,SMALL_BAT_HEIGHT,m_smallBatHeight);
	pApp->WriteProfileInt(PARAM_SECTION,BALL_WIDTH,m_ballWidth);
	pApp->WriteProfileInt(PARAM_SECTION,COMPUTER_SPEED,m_computerSpeed);
	pApp->WriteProfileInt(PARAM_SECTION,PLAYER1_UP_KEY,m_upKeyP1);
	pApp->WriteProfileInt(PARAM_SECTION,PLAYER1_DOWN_KEY,m_downKeyP1);
	pApp->WriteProfileInt(PARAM_SECTION,PLAYER2_UP_KEY,m_upKeyP2);
	pApp->WriteProfileInt(PARAM_SECTION,PLAYER2_DOWN_KEY,m_downKeyP2);
	pApp->WriteProfileInt(PARAM_SECTION,EFFECT_ANGOLATION,m_maxEffect);
}

void COptionsDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int* pValue = NULL;
	int nID = pScrollBar->GetDlgCtrlID();

	if (nID==IDC_LOWSPEEDVALUE)
		pValue = &m_loSpeedValue;
		
	if (nID==IDC_HIGHSPEEDVALUE)
		pValue = &m_hiSpeedValue;
		
	if (nID==IDC_BIGBAT)
		pValue = &m_bigBatHeight;
		
	if (nID==IDC_SMALLBAT)
		pValue = &m_smallBatHeight;
		
	if (nID==IDC_BALLWIDTH)
		pValue = &m_ballWidth;     
		
	if (nID==IDC_MAX_EFFECT)
		pValue = &m_maxEffect;
		
	if (pValue!=NULL)
	{
		int minPos, maxPos;
		int scrollPos = pScrollBar->GetScrollPos();
		pScrollBar->GetScrollRange(&minPos,&maxPos);
	
		switch (nSBCode)
		{
			case SB_LEFT			:	scrollPos = minPos;
										break;
			case SB_LINELEFT		:	if (scrollPos>minPos)
											scrollPos--;
										break;	
			case SB_PAGELEFT		:	scrollPos -= (maxPos-minPos)/10 + 1;
										if (scrollPos<minPos)
											scrollPos = minPos;
										break;
			case SB_RIGHT			:   scrollPos = maxPos;
										break;
			case SB_LINERIGHT		:	if (scrollPos<maxPos)
											scrollPos++;
										break;	
			case SB_PAGERIGHT		:	scrollPos += (maxPos-minPos)/10 + 1;
										if (scrollPos>maxPos)
											scrollPos = maxPos;
										break;	
			case SB_THUMBPOSITION	:	
			case SB_THUMBTRACK		:	scrollPos = (int)nPos;
		}
	
		// Update ScrollBar Cursor Position
		*pValue = scrollPos;
		pScrollBar->SetScrollPos(scrollPos);

		// Update Float Data
		char buffer[8];
		if (nID==IDC_LOWSPEEDVALUE)
			GetDlgItem(IDC_LS_VALUE)->SetWindowText(_itoa(scrollPos,buffer,10));
		
		if (nID==IDC_HIGHSPEEDVALUE)
			GetDlgItem(IDC_HS_VALUE)->SetWindowText(_itoa(scrollPos,buffer,10));
		
		if (nID==IDC_BIGBAT)
			GetDlgItem(IDC_BBH_VALUE)->SetWindowText(_itoa(scrollPos,buffer,10));
		
		if (nID==IDC_SMALLBAT)
			GetDlgItem(IDC_SBH_VALUE)->SetWindowText(_itoa(scrollPos,buffer,10));
		
		if (nID==IDC_BALLWIDTH)
			GetDlgItem(IDC_BW_VALUE)->SetWindowText(_itoa(scrollPos,buffer,10));
		
		if (nID==IDC_MAX_EFFECT)
			GetDlgItem(IDC_ME_VALUE)->SetWindowText(_itoa(scrollPos,buffer,10));
	}
	else
		CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
