// dlg.h : header file
//


#include "resource.h"


/////////////////////////////////////////////////////////////////////////////
// CColorsDlg dialog

class CColorsDlg : public CDialog
{
// Construction
public:
	CColorsDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CColorsDlg)
	enum { IDD = IDD_COLORSDLG };
	CComboBox	m_paper;
	CComboBox	m_ink;
	CString		m_selInk;
	CString		m_selPaper;
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	//{{AFX_MSG(CColorsDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};





/////////////////////////////////////////////////////////////////////////////
// CComputerSkillDlg dialog

class CComputerSkillDlg : public CDialog
{
// Construction
public:
	CComputerSkillDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CComputerSkillDlg)
	enum { IDD = IDD_COMPUTERDLG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA
	
    // Public Interface
    int m_computerSkill;
    
// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	//{{AFX_MSG(CComputerSkillDlg)
	afx_msg void OnClickedFast();
	afx_msg void OnClickedMedium();
	afx_msg void OnClickedSlow();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};





/////////////////////////////////////////////////////////////////////////////
// CKeyboardDlg dialog

class CKeyboardDlg : public CDialog
{
// Construction
public:
	CKeyboardDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CKeyboardDlg)
	enum { IDD = IDD_KEYBOARDDLG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// Public Interface
	UINT m_p1Up;
	UINT m_p1Down;
	UINT m_p2Up;
	UINT m_p2Down;

	void CloseAskingWindow();
	void KeyPressed(UINT keyPressed);	

// Implementation
protected:
	CWnd*	m_pAskingWnd;	
	UINT*	m_pUpdatingKey;

	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	//{{AFX_MSG(CKeyboardDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnChangeP1Down();
	afx_msg void OnChangeP1Up();
	afx_msg void OnChangeP2Down();
	afx_msg void OnChangeP2Up();
	virtual void OnCancel();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};





/////////////////////////////////////////////////////////////////////////////
// CWaitKeyDlg Window: Designed for Dynamic Usage Only

class CWaitKeyDlg : public CWnd
{
	DECLARE_DYNCREATE(CWaitKeyDlg);
public:
	BOOL Create(CWnd* pParent = NULL);

	CString m_player;
	CString m_direction;
	
	CKeyboardDlg* m_pOwnerWnd;

protected:
	// Generated message map functions
	//{{AFX_MSG(CWaitKeyDlg)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnPaint();
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnSysKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	virtual void PostNcDestroy();
};





/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog

class COptionsDlg : public CDialog
{
// Construction
public:
	COptionsDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(COptionsDlg)
	enum { IDD = IDD_OPTIONSDLG };
	CComboBox	m_games;
	BOOL	m_accelerated;
	BOOL	m_effect;
	BOOL	m_largeBats;
	BOOL	m_sound;
	BOOL	m_hiSpeed;
	int		m_winnerScore;
	BOOL	m_scoresAlwaysOnTop;
	CString	m_currGame;
	//}}AFX_DATA

	// Public Interface
	int	m_loSpeedValue;
	int	m_hiSpeedValue;
	int m_bigBatHeight;
	int m_smallBatHeight;
	int m_ballWidth;
	int m_maxEffect;
	
	COLORREF m_ink;
	COLORREF m_paper;
	
	UINT m_upKeyP1;
	UINT m_downKeyP1;
	UINT m_upKeyP2;
	UINT m_downKeyP2;
	
	int m_computerSpeed;
	
// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	//{{AFX_MSG(COptionsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnClickedColors();
	afx_msg void OnClickedKeys();
	afx_msg void OnClickedDefaults();
	afx_msg void OnClickedSkill();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnClickedSave();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};





